
{*******************************************************}
{                                                       }
{       Image Controls                                  }
{                      }
{                                                       }
{       Copyright (c) 2004-2005,          }
{                               (s-mike)                }
{       http://mikesoft.front.ru                        }
{       http://forum.sources.ru                         }
{                                                       }
{*******************************************************}

// !!!
// TODO: NavigatorForm component?

{
@abstract( ,    
  @link(TCustomScrollingImage).)
@author(  <mikesoft@front.ru>)
@created(1 , 2004)
@lastmod(19 , 2005)
}

unit ScrollingImageAddons;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, Messages, Graphics, ScrollingImage;

type
  //{ @abstract(,    
  //   @link(TScrollingImageNavigator).) }
  {@exclude}
  TOwnShape = class(TGraphicControl)
  private
    FPen: TPen;
    FBrush: TBrush;
    procedure SetBrush(Value: TBrush);
    procedure SetPen(Value: TPen);
  protected                                             {@exclude}
    procedure Paint; override;
  public                                                {@exclude}
    constructor Create(AOwner: TComponent); override;   {@exclude}
    destructor Destroy; override;
  published                                             {@exclude}
    procedure StyleChanged(Sender: TObject);
                                                        {@exclude}
    property Brush: TBrush read FBrush write SetBrush;  {@exclude}
    property Cursor default crSizeAll;                  {@exclude}
    property Enabled;                                   {@exclude}
    property ParentShowHint;                            {@exclude}
    property Pen: TPen read FPen write SetPen;          {@exclude}
    property ShowHint;                                  {@exclude}
    property Visible;
                                                        {@exclude}
    property OnClick;                                   {@exclude}
    property OnContextPopup;                            {@exclude}
    property OnResize;
  end;

  { ,      .
     <b>ABitmap</b>     
     . }
  TCustomNavigatorEvent = procedure(const ABitmap: TBitmap) of object;
  {       .
     <b>ASource</b>, <b>ADest</b>   
       ,  
    <b>AWidth</b>, <b>AHeight</b>  ,
         . }
  TCustomScalingEvent = procedure(const ASource, ADest: TBitmap;
    const AWidth, AHeight: Integer) of object;

  {       True
     @link(CustomNavigator).    ,
        . }
  TNavigatorChange = (
    {      
      @link(OnCustomNavigator). }
    ncAuto,
    {    
         @link(SetNavigator),  
         . }
    ncManual
  );

  { @abstract(,    @link(TCustomScrollingImage).) }  
  TScrollingImageNavigator = class(TCustomControl)
  private
    FShape: TOwnShape;
    FScrollingImage: TCustomScrollingImage;
    FBitmap: TBitmap;
    FOldOnChangePos: TNotifyEvent;
    FOldOnChangeImage: TNotifyEvent;
    FOldOnResize: TNotifyEvent;
    FScaleFactor, FHScaleFactor, FVScaleFactor: Extended;
    FBitmapLeft, FBitmapTop: Integer;
    FDraggingShape: Boolean;
    FCustomNavigator: Boolean;
    FOnCustomNavigator: TCustomNavigatorEvent;
    FOnCustomScaling: TCustomScalingEvent;
    FNavigatorChange: TNavigatorChange;
    function PointInBitmap(const X, Y: Integer): Boolean;
    procedure SetScrollingImage(const Value: TCustomScrollingImage);
    procedure OnImageChanged(Sender: TObject);
    procedure OnPosChanged(Sender: TObject);
    procedure OnSizeChanged(Sender: TObject);
    procedure ShapeMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ShapeMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure ShapeMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure WMEraseBkgnd(var Message: TMessage); message WM_ERASEBKGND;
    procedure CMColorChanged(var Message: TMessage); message CM_COLORCHANGED;
    procedure SetCustomNavigator(const Value: Boolean);
  protected                                                           {@exclude}
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;                                       {@exclude}
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override; {@exclude}
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;                                       {@exclude}
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;                               {@exclude}
    procedure Paint; override;                                        {@exclude}
    procedure Resize; override;

    //       
    {@exclude}
    procedure ChangeShapePosition(const X, Y: Integer); virtual;
    //      TCustomScrollingImage
    {@exclude}
    procedure ImageChanged; virtual;
    //        TCustomScrollingImage 
    {@exclude}
    procedure PosChanged; virtual;
    //     
    {@exclude}
    procedure SizeChanged; virtual;
  public                                               {@exclude}
    constructor Create(AOwner: TComponent); override;  {@exclude}
    destructor Destroy; override;

    {      
      @link(NavigatorChange) = ncManual. }
    procedure SetNavigator(const ABitmap: TBitmap);
  published
    { ,     
      @link(OnCustomNavigator)     
         . }
    property CustomNavigator: Boolean read FCustomNavigator write SetCustomNavigator default False;
    { ,     
         @link(CustomNavigator)=True. }
    property NavigatorChange: TNavigatorChange read FNavigatorChange write FNavigatorChange default ncAuto;
    {   - TCustomScrollingImage. }
    property ScrollingImage: TCustomScrollingImage read FScrollingImage write SetScrollingImage;
    {     . }    
    property Shape: TOwnShape read FShape;

    { ,      ,
       @link(CustomNavigator)=True  @link(NavigatorChange)=ncAuto. }
    property OnCustomNavigator: TCustomNavigatorEvent read FOnCustomNavigator write FOnCustomNavigator;
    {     
       . }
    property OnCustomScaling: TCustomScalingEvent read FOnCustomScaling write FOnCustomScaling;
                                     {@exclude}
    property Align;                  {@exclude}
    property Anchors;                {@exclude}
    property Color;                  {@exclude}
    property Constraints;            {@exclude}
    property Cursor default crCross; {@exclude}
    property DragCursor;             {@exclude}
    property DragKind;               {@exclude}
    property DragMode;               {@exclude}
    property Enabled;                {@exclude}    
    property ParentColor;            {@exclude}
    property PopupMenu;              {@exclude}
    property ShowHint;               {@exclude}
    property ParentShowHint;         {@exclude}
    property Visible;
                                     {@exclude}
    property OnClick;                {@exclude}
    property OnContextPopup;         {@exclude}
    property OnDblClick;             {@exclude}
    property OnDragDrop;             {@exclude}
    property OnDragOver;             {@exclude}
    property OnEndDock;              {@exclude}
    property OnEndDrag;              {@exclude}
    property OnMouseDown;            {@exclude}
    property OnMouseMove;            {@exclude}
    property OnMouseUp;              {@exclude}
    property OnResize;               {@exclude}
    property OnStartDock;            {@exclude}
    property OnStartDrag;
  end;

implementation

uses Types, MiniMath;

// *****************************************************************************
//   TOwnShape
// *****************************************************************************

constructor TOwnShape.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  SetSubComponent(True);

  ControlStyle := ControlStyle + [csReplicatable];
  Width := 65;
  Height := 65;
  FPen := TPen.Create;
  FPen.Color := clRed;
  FPen.Width := 2;
  FPen.OnChange := StyleChanged;

  FBrush := TBrush.Create;
  FBrush.Style := bsClear;
  FBrush.OnChange := StyleChanged;

  Cursor := crSizeAll;
end;

destructor TOwnShape.Destroy;
begin
  FPen.Free;
  FBrush.Free;
  inherited Destroy;
end;

procedure TOwnShape.Paint;
var
  X, Y, W, H: Integer;
begin
  with Canvas do
  begin
    Pen := FPen;
    Brush := FBrush;
    X := Pen.Width div 2;
    Y := X;
    W := Width - Pen.Width + 1;
    H := Height - Pen.Width + 1;
    if Pen.Width = 0 then
    begin
      Dec(W);
      Dec(H);
    end;
    Rectangle(X, Y, X + W, Y + H);
  end;
end;

procedure TOwnShape.StyleChanged(Sender: TObject);
begin
  Invalidate;
end;

procedure TOwnShape.SetBrush(Value: TBrush);
begin
  FBrush.Assign(Value);
end;

procedure TOwnShape.SetPen(Value: TPen);
begin
  FPen.Assign(Value);
end;

// *****************************************************************************
//   TScrollingImageNavigator
// *****************************************************************************

procedure TScrollingImageNavigator.ChangeShapePosition(const X,
  Y: Integer);
begin
  if Assigned(FScrollingImage) and (FScaleFactor > 0) then
    FScrollingImage.ImagePos :=
      Point(Trunc((X - FBitmapLeft - FShape.Width div 2) / FHScaleFactor),
            Trunc((Y - FBitmapTop - FShape.Height div 2) / FVScaleFactor));
end;

procedure TScrollingImageNavigator.CMColorChanged(var Message: TMessage);
begin
  Invalidate;
end;

constructor TScrollingImageNavigator.Create(AOwner: TComponent);
begin
  inherited;

  FScaleFactor := 0;
  FHScaleFactor := 0;
  FVScaleFactor := 0;

  FOldOnChangePos := nil;
  FOldOnChangeImage := nil;
  FOldOnResize := nil;

  ScrollingImage := nil;
  //  ,   FScrollingImage := nil,    
  //    ScrollingImageChanged
  FShape := TOwnShape.Create(Self);
  FShape.Parent := Self;
  FShape.OnMouseDown := ShapeMouseDown;
  FShape.OnMouseMove := ShapeMouseMove;
  FShape.OnMouseUp := ShapeMouseUp;

  FBitmap := TBitmap.Create;

  Cursor := crCross;
  FCustomNavigator := False;
  FNavigatorChange := ncAuto;
end;

destructor TScrollingImageNavigator.Destroy;
begin
  FBitmap.Free;

  inherited;
end;

procedure TScrollingImageNavigator.ImageChanged;
begin
  if (not Assigned(FScrollingImage)) or (FScrollingImage.Empty) then Exit;

  if FCustomNavigator then
  begin
    if (FNavigatorChange = ncAuto) and Assigned(FOnCustomNavigator) then FOnCustomNavigator(FBitmap);
    FScaleFactor := FBitmap.Width / FScrollingImage.PictureWidth;
    FHScaleFactor := FBitmap.Width / FScrollingImage.PictureWidth;
    FVScaleFactor := FBitmap.Height / FScrollingImage.PictureHeight;
  end else begin
    if ClientWidth < ClientHeight then
      FScaleFactor := ClientWidth / FScrollingImage.PictureWidth
    else
      FScaleFactor := ClientHeight / FScrollingImage.PictureHeight;
    FHScaleFactor := FScaleFactor;
    FVScaleFactor := FScaleFactor;
    FBitmap.Width := Trunc(FScrollingImage.PictureWidth * FScaleFactor);
    FBitmap.Height := Trunc(FScrollingImage.PictureHeight * FScaleFactor);
    if Assigned(FOnCustomScaling) then
      FOnCustomScaling(FScrollingImage.Picture, FBitmap, FBitmap.Width, FBitmap.Height)
    else
      FBitmap.Canvas.StretchDraw(FBitmap.Canvas.ClipRect, FScrollingImage.Picture);
  end;

  FBitmapLeft := (ClientWidth - FBitmap.Width) div 2;
  FBitmapTop := (ClientHeight - FBitmap.Height) div 2;

  SizeChanged;
  PosChanged;
end;

procedure TScrollingImageNavigator.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);

  if not PointInBitmap(X, Y) then Exit;

  if Button = mbLeft then
  begin
    FDraggingShape := True;
    ChangeShapePosition(X, Y);
  end;
end;

procedure TScrollingImageNavigator.MouseMove(Shift: TShiftState; X,
  Y: Integer);
begin
  inherited;

  if FDraggingShape then
    ChangeShapePosition(X, Y)
  else
    if PointInBitmap(X, Y) then
      Screen.Cursor := crDefault
    else
      Screen.Cursor := crArrow;
end;

procedure TScrollingImageNavigator.MouseUp(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  inherited;

  FDraggingShape := False;
end;

procedure TScrollingImageNavigator.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
    if (AComponent = FScrollingImage) then
      ScrollingImage := nil;
  end;
end;

procedure TScrollingImageNavigator.OnImageChanged(Sender: TObject);
begin
  ImageChanged;
  Invalidate;

  if Assigned(FOldOnChangeImage) then FOldOnChangeImage(Sender);
end;

procedure TScrollingImageNavigator.OnPosChanged(Sender: TObject);
begin
  PosChanged;

  if Assigned(FOldOnChangePos) then FOldOnChangePos(Sender);
end;

procedure TScrollingImageNavigator.OnSizeChanged(Sender: TObject);
begin
  SizeChanged;

  if Assigned(FOldOnResize) then FOldOnResize(Sender);
end;

procedure TScrollingImageNavigator.Paint;
begin
  if csDesigning in ComponentState then
    with Canvas do
    begin
      Pen.Style := psDash;
      Pen.Color := clBlack;
      Brush.Color := Color;
      Brush.Style := bsSolid;
      Rectangle(0, 0, ClientWidth, ClientHeight);
    end;

  with Canvas do
  begin
    Brush.Color := Color;
    FillRect(Rect(0, 0, ClientWidth, FBitmapTop));
    FillRect(Rect(0, FBitmapTop + FBitmap.Height, ClientWidth, ClientHeight));
    FillRect(Rect(0, 0, FBitmapLeft, ClientHeight));
    FillRect(Rect(FBitmapLeft + FBitmap.Width, 0, ClientWidth, ClientHeight));
    Draw(FBitmapLeft, FBitmapTop, FBitmap);
  end;
end;

function TScrollingImageNavigator.PointInBitmap(const X,
  Y: Integer): Boolean;
begin
  Result := not
    ((X < FBitmapLeft) or (Y < FBitmapTop) or
     (X > FBitmapLeft + FBitmap.Width) or (Y > FBitmapTop + FBitmap.Height));
end;

procedure TScrollingImageNavigator.PosChanged;
begin
  FShape.Left := FBitmapLeft + Round(FHScaleFactor * FScrollingImage.ImageLeft);
  FShape.Top := FBitmapTop + Round(FVScaleFactor * FScrollingImage.ImageTop); 
end;

procedure TScrollingImageNavigator.Resize;
begin
  inherited Resize;

  ImageChanged;
end;

procedure TScrollingImageNavigator.SetCustomNavigator(
  const Value: Boolean);
begin
  if FCustomNavigator <> Value then
  begin
    FCustomNavigator := Value;
    ImageChanged;
  end;
end;

procedure TScrollingImageNavigator.SetNavigator(const ABitmap: TBitmap);
begin
  if FNavigatorChange = ncAuto then Exit;

  FBitmap.Assign(ABitmap);
  ImageChanged;
end;

procedure TScrollingImageNavigator.SetScrollingImage(
  const Value: TCustomScrollingImage);
begin
  if FScrollingImage <> Value then
  begin
    if not (csDesigning in ComponentState) then
      if Assigned(FScrollingImage) then
        with FScrollingImage do
        begin
          OnChangePos := FOldOnChangePos;
          OnChangeImage := FOldOnChangeImage;
          OnChangeSize := FOldOnResize;
        end;

    FScrollingImage := Value;

    if not (csDesigning in ComponentState) then
      if Assigned(FScrollingImage) then
        with FScrollingImage do
        begin
          FOldOnChangePos := OnChangePos;
          FOldOnChangeImage := OnChangeImage;
          FOldOnResize := OnResize;

          OnChangePos := OnPosChanged;
          OnChangeImage := OnImageChanged;
          OnChangeSize := OnSizeChanged;
        end;
        
    ImageChanged;
  end;
end;

procedure TScrollingImageNavigator.ShapeMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin
    FDraggingShape := True;
    ChangeShapePosition(FShape.Left + X, FShape.Top + Y);
  end;
end;

procedure TScrollingImageNavigator.ShapeMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if FDraggingShape then
    ChangeShapePosition(FShape.Left + X, FShape.Top + Y)
  else
    Screen.Cursor := crDefault;
end;

procedure TScrollingImageNavigator.ShapeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FDraggingShape := False;
end;

procedure TScrollingImageNavigator.SizeChanged;
begin
  FShape.Width := Trunc(FHScaleFactor * Min(ScrollingImage.PictureWidth, ScrollingImage.ClientWidth));
  FShape.Height := Trunc(FVScaleFactor * Min(ScrollingImage.PictureHeight, ScrollingImage.ClientHeight));
end;

procedure TScrollingImageNavigator.WMEraseBkgnd(var Message: TMessage);
begin
  Message.Result := 1;
end;

end.
